

// Name
//===================================
//
// Clock
//


// DEPENDENCIES
//===================================

    #include "clock.h"
    #include <cmath>


// STATIC PROPERTIES
//===================================

// METHODS
//===================================

    Clock::Clock
    (
        int start_time,
        Direction::Vertical direction,
        int limit
    )
    :
        total_seconds_ ( start_time ),
        direction_ ( direction ),
        limit_ ( limit )
    {};

    Clock::~Clock() {};

    void Clock::update()
    {
        if ( timer_.hit() )
        {
            if ( direction_ == Direction::Vertical::DOWN )
            {
                --total_seconds_;

                if ( total_seconds_ < limit_ )
                    total_seconds_ = limit_;
            }
            else
            {
                ++total_seconds_;

                if ( total_seconds_ > limit_ )
                    total_seconds_ = limit_;
            }
        }

        timer_.update();
    };

    int Clock::secondsFromTotal() const
    {
        return total_seconds_ % SECONDS_PER_MINUTE;
    };

    int Clock::minutesFromTotalSeconds() const
    {
        return floor( total_seconds_ / SECONDS_PER_MINUTE );
    };

    int Clock::totalSeconds() const
    {
        return total_seconds_;
    };
