




// Name
//===================================
//
// Clock
//

#ifndef CLOCK_H
#define CLOCK_H


// FORWARD DECLARATIONS
//===================================


// DEPENDENCIES
//===================================

    #include "timers/timer_repeat.h"
    #include "unit.h"


// CLASS
//===================================

    class Clock
    {
        public:
            Clock( int start_time = 0, Direction::Vertical direction = Direction::Vertical::UP, int limit = 599 );
            ~Clock();

            int total_seconds_;
            int limit_;
            Direction::Vertical direction_;

            void update();
            int secondsFromTotal() const;
            int minutesFromTotalSeconds() const;
            int totalSeconds() const;

        private:
            static const int SECONDS_PER_MINUTE = 60;
            TimerRepeat timer_ = TimerRepeat( Unit::FPS );
    };

#endif // CLOCK_H

