

// Name
//===================================
//
// CollectGoal
//


// DEPENDENCIES
//===================================

    #include "collect_goal.h"
    #include "event_system.h"
    #include "inventory.h"
    #include "text.h"


// STATIC PROPERTIES
//===================================


// METHODS
//===================================

    CollectGoal::CollectGoal( int num )
    :
        num_ ( num ),
        Goal( GoalType::COLLECT, num )
    {};

    CollectGoal::~CollectGoal() {};

    void CollectGoal::update( Inventory& inventory, EventSystem& events )
    {
        if ( inventory.funds() >= num_ )
            events.won_ = true;
    };

    std::string CollectGoal::message()
    {/*
        std::ostringstream oss;
        oss << "¡Collect " << stringifyNum( num_ ) << "\t!";

        return oss.str();*/
        return (std::string)"¡Collect " + Text::formatNumCommas( Text::stringifyNum( num_ ) ) + (std::string)"\t!";
    };
