
// Name
//===================================
//
// Collision
//

#ifndef COLLISION_H
#define COLLISION_H


// FORWARD DECLARATIONS
//===================================


// DEPENDENCIES
//===================================

    #include "direction.h"


// CLASS
//===================================

    class Collision
    {
        public:
            int overlapXLeft()                 const;
            int overlapXRight()                const;
            int overlapYTop()                  const;
            int overlapYBottom()               const;
            bool collideLeft()                 const;
            bool collideRight()                const;
            bool collideTop()                  const;
            bool collideBottom()               const;
            bool collideAny()                  const;

            Collision
            (
                int overlap_x_left,
                int overlap_x_right,
                int overlap_y_top,
                int overlap_y_bottom
            );

        private:
            const int overlap_x_left_;
            const int overlap_x_right_;
            const int overlap_y_top_;
            const int overlap_y_bottom_;
    };

#endif // COLLISION_H
