

// Name
//===================================
//
// LevelSelectState
//

#ifndef LEVEL_SELECT_STATE_H
#define LEVEL_SELECT_STATE_H


// FORWARD DECLARATIONS
//===================================

    class EventSystem;
    class Inventory;


// DEPENDENCIES
//===================================

    #include "game_state.h"
    #include "level.h"
    #include "sprite_graphics.h"
    #include "text.h"


// CLASS
//===================================

    class LevelSelectState : public GameState
    {

        public:
            LevelSelectState( EventSystem* events = nullptr, Inventory* inventory = nullptr );
            ~LevelSelectState();

            void update( Game& game, Input& input, Graphics& graphics );
            void stateRender( Graphics& graphics );
            void init( Game& game, Graphics& graphics );
            void backFromPop( Game& game, Graphics& graphics );

        private:
            int START_Y = 48;
            EventSystem* events_;
            Inventory* inventory_;
            //SpriteGraphics arrow_gfx_ = SpriteGraphics( Graphics::SpriteSheet::CHARSET, 6*8, 2*8 );
            //SDL_Rect arrow_rect_ = { 16, START_Y, 8, 8 };
            SDL_Rect highlight_rect_ = { 16, START_Y, Unit::WINDOW_WIDTH_PIXELS - 32, 8 };
            Text title_ = Text( "Select a Level, yo.", 0, 16, Text::FontShade::BLACK, Text::FontAlign::FA_CENTER );
            std::vector<Text> levels_;
            Counter selection_ = Counter( 0, Level::LevelName::LV_LIMIT-1, 0 );
    };

#endif // LEVEL_SELECT_STATE_H
