


// Name
//===================================
//
// TimedGoal
//


// DEPENDENCIES
//===================================

    #include "timed_goal.h"
    #include "event_system.h"
    #include "inventory.h"
    #include "text.h"


// STATIC PROPERTIES
//===================================


// METHODS
//===================================

    TimedGoal::TimedGoal( int time_limit )
    :
        time_limit_ ( time_limit ),
        Goal( GoalType::TIMED, time_limit )
    {};

    TimedGoal::~TimedGoal() {};

    void TimedGoal::update( Inventory& inventory, EventSystem& events )
    {
        if ( inventory.clockTime() <= 0 )
            events.failed_ = true;
    };

    std::string TimedGoal::message()
    {
        return "¡Don't let time run out!";
    };
